#include <stdio.h>

int qfind(long Clock, long Start, long Stop, long *Array)
{

      long Actual;
      long lo = Start;
      long hi = Stop;
      long clk;

      while (lo < hi)
      {
	Actual  = (hi + lo) / 2;
        clk = Array[Actual];
        if (clk < Clock)
          lo = Actual + 1;
	else
	  hi = Actual;
      }
      if (Actual < Stop-1 && clk < Clock)
        clk = Array [ ++ Actual ];
      if (Actual < Stop && clk >= Clock)
        return Array[Actual];
      return -23;
}

int sfind(long Clock, long Start, long Stop, long *Array)
{
  int i;
  for (i = Start; i < Stop; i++)
    if (Array[i] >= Clock)
      return Array[i];
  return -23;
}


int main(void)
{
  static long arr[6] = {2,4,6,8,10, 20};
  int lo, hi, ky;

  for (hi = 0; hi <= 6; hi++)
  {
    for (lo = 0; lo <= hi; lo++)
    {
      for (ky = 0; ky < 25; ky++)
      {
        if (qfind(ky, lo, hi, arr) != sfind(ky, lo, hi, arr))
          printf("error: lo %d, hi %d, ky %d\n", lo, hi, ky);
      }
    }
  }
  return 0;
}


